/* Tabela PRODUTOSEG: */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes
na tabela PRODUTOSEG */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Item do PRODUTOSEG,
utilizando a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_GER_PRODUTOSEG
AFTER DELETE OR INSERT OR UPDATE
ON PRODUTOSEG FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   IF DELETING THEN
      IF :OLD.CDPRODUTO IS NOT NULL THEN
         V_DESC := V_DESC || 'Produto=' || :OLD.CDPRODUTO;
      END IF;

      IF :OLD.CDSEGMER IS NOT NULL THEN
         V_DESC := V_DESC || ' CodSegMerc=' || :OLD.CDSEGMER;
      END IF;

      IF :OLD.IDPROSEGATIV IS NOT NULL THEN
         V_DESC := V_DESC || ' Ativo=' || :OLD.IDPROSEGATIV;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDSEGMER || :OLD.CDPRODUTO;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDPRODUTO     <> :NEW.CDPRODUTO)     OR
            (:OLD.CDSEGMER      <> :NEW.CDSEGMER)     OR
            (NVL(:OLD.IDPROSEGATIV,'!')  <> NVL(:NEW.IDPROSEGATIV,'!')) THEN

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDSEGMER || :OLD.CDPRODUTO;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDSEGMER || :NEW.CDPRODUTO;
      END IF;
      IF :NEW.CDPRODUTO IS NOT NULL THEN
         V_DESC := V_DESC || 'CodProduto=' || :NEW.CDPRODUTO;
      END IF;

      IF :NEW.CDSEGMER IS NOT NULL THEN
         V_DESC := V_DESC || ' codSegMerc=' || :NEW.CDSEGMER;
      END IF;

      IF NVL(:NEW.IDPROSEGATIV,'!') <> NVL(:OLD.IDPROSEGATIV,'!') THEN
         V_DESC := V_DESC || ' Ativo=' || :NEW.IDPROSEGATIV;
      END IF;

   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('PRODUTOSEG',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_PRODUTOSEG','4.09.060'); END;
/
